/*******************************************************************************
* Copyright (c) 2015-2016 ONERA.
 * Ce logiciel est la propriété de l’ONERA (the French Aerospace Lab).
 * Tous droits réservés.
 *
 * Ce programme et les éléments qui l'accompagnent sont mis à disposition
 * aux conditions définies par le contrat de licence logiciel CeCILL-C soumise
 * au droit français et respectant les principes de diffusion des logiciels libres.
 * Vous pouvez utiliser, modifier et/ou redistribuer ce programme
 * sous les conditions de la licence CeCILL-C (http://www.cecill.info).

 * This software is property of ONERA (the French Aerospace Lab).
 * All rights reserved.
 *
 * This program and the accompanying materials are made available under
 * the terms of the CeCILL-C license under French law and
 * abiding by the rules of distribution of free software.
 * You can  use, modify and/ or redistribute the software under the terms of
 * the CeCILL-C license (http://www.cecill.info).
 *
 * Contributeurs/contributors:
*     Guillaume Infantes (ONERA - Centre de Toulouse) - initial API and implementation
*     
 *******************************************************************************/

#ifndef ALTA_VALUE_BOOL_H
#define ALTA_VALUE_BOOL_H

#include <set>
#include "Value.hh"

namespace epoch {
    namespace altarica {

	class ValueInt;
	class ValueSymbol;

	

	class ValueBool : public Value {

	protected:
	    bool t_;
	    bool b_;
	public:

	    virtual bool isBool() const {return true;}

	    ValueBool();
	    ValueBool(bool t, bool b);
	    virtual ~ValueBool() {}
	    virtual ValueBool * clone() const;
	    void allowTop(bool b);
	    void allowBottom(bool b);
	    bool allowedTop() const {return t_;}
	    bool allowedBottom() const {return b_;}
	    virtual void inverse();
	    virtual bool constrained() const {return t_ && b_;}

	    virtual bool toBool() const;
	    virtual int toHash() const ;

	    virtual bool pDifferent(const ValueBool *v) const;	    

	    virtual bool equals(const ValueBool*v) const;

	    virtual void merge(const ValueBool*v);
	    virtual bool contains(const ValueBool *fb)const;

	    virtual bool possible(bool b) const;
	    virtual ValueBool* getComplement() const;

	    virtual void intersectValue(const ValueBool* v);

	    void land(const ValueBool *v);
	    void lor(const ValueBool *v);
	    virtual std::vector<Value*> * getSingletons() const;
	    virtual bool hasIntersection(const ValueBool*v)const;

	    virtual void removeValue(const ValueBool *v);

	    virtual bool less(const ValueBool *v) const;
	    virtual bool less(const ValueSymbol *v) const {return true;}
	    virtual int card() const {return t_? 1:0;}

	    virtual std::string toString() const;
	};





    }
}


#endif
